



#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    set ModuleMenu {"CAEN_V785" SAC}

    variable A16Base 0x0000
    variable A24Base 0x000000
    variable A32Base 0x00000000

    for {set i 0} {$i < 15} {incr i} {
       set ModuleType($i) ""
       set ModuleName($i) ""
       set ModuleAddress($i) ""
    }

   variable moduletype [first $ModuleMenu]
   variable moduleindex 1


   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
        variable LogFlag
        variable ShowLogFlag
        variable moduletype
        variable moduleindex

        InsertLog "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base"
        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "moduletype=$moduletype; moduleindex=$moduleindex"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                   ADDRESS  {
                         switch [lindex $w 1] {
                             A16   {variable A16Base; set A16Base [lindex $w 2]; InsertLog "A16 Base = $A16Base"}
                             A24   {variable A24Base; set A24Base [lindex $w 2]; InsertLog "A24 Base = $A24Base"}
                             A32   {variable A32Base; set A32Base [lindex $w 2]; InsertLog "A32 Base = $A32Base"}
                         }
                   }

                ADD  {}
                REPLACE {}
                DELETE {}
                CLEAR {}
                SAVE {}
                LOAD {}

                INDEX {variable moduleindex; set moduleindex [lindex $w 1]}
                TYPE  {variable moduletype;  set moduletype [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }


}  ;# end of if {$started == 0}

